All of lore.kernel.org
 help / color / mirror / Atom feed
From: Arnaldo Carvalho de Melo <acme@kernel.org>
To: Ingo Molnar <mingo@kernel.org>
Cc: linux-kernel@vger.kernel.org, linux-perf-users@vger.kernel.org,
	Arnaldo Carvalho de Melo <acme@redhat.com>,
	Adrian Hunter <adrian.hunter@intel.com>,
	David Ahern <dsahern@gmail.com>, Jiri Olsa <jolsa@kernel.org>,
	Michael Petlan <mpetlan@redhat.com>,
	Namhyung Kim <namhyung@kernel.org>,
	Thomas Richter <tmricht@linux.vnet.ibm.com>,
	Wang Nan <wangnan0@huawei.com>
Subject: [PATCH 10/19] perf test shell: Add 'probe_vfs_getname' shell test
Date: Mon, 14 Aug 2017 13:27:32 -0300	[thread overview]
Message-ID: <20170814162741.6101-11-acme@kernel.org> (raw)
In-Reply-To: <20170814162741.6101-1-acme@kernel.org>

From: Arnaldo Carvalho de Melo <acme@redhat.com>

First perf shell test:

  # perf test vfs_getname
  60: Add vfs_getname probe to get syscall args filenames: Ok
  #

In verbose mode:

  # perf test -v vfs_getname
  60: Add vfs_getname probe to get syscall args filenames:
  --- start ---
  test child forked, pid 19146
  Added new event:
    probe:vfs_getname    (on getname_flags:72 with pathname=result->name:string)

  You can now use it in all perf tools, such as:

	  perf record -e probe:vfs_getname -aR sleep 1

  test child finished with 0
  ---- end ----
  Add vfs_getname probe to get syscall args filenames: Ok
  #

And if the vmlinux file is not found:

  # mv ../build/v4.12.0-rc6+/vmlinux ../build/v4.12.0-rc6+/vmlinux.hidden
  # perf test vfs_getname
  60: Add vfs_getname probe to get syscall args filenames: Skip
  #

Cc: Adrian Hunter <adrian.hunter@intel.com>
Cc: David Ahern <dsahern@gmail.com>
Cc: Jiri Olsa <jolsa@kernel.org>
Cc: Michael Petlan <mpetlan@redhat.com>
Cc: Namhyung Kim <namhyung@kernel.org>
Cc: Thomas Richter <tmricht@linux.vnet.ibm.com>
Cc: Wang Nan <wangnan0@huawei.com>
Link: http://lkml.kernel.org/n/tip-8f3n22c1yn516ev30s603ow2@git.kernel.org
Signed-off-by: Arnaldo Carvalho de Melo <acme@redhat.com>
---
 tools/perf/tests/shell/probe_vfs_getname.sh | 30 +++++++++++++++++++++++++++++
 1 file changed, 30 insertions(+)
 create mode 100755 tools/perf/tests/shell/probe_vfs_getname.sh

diff --git a/tools/perf/tests/shell/probe_vfs_getname.sh b/tools/perf/tests/shell/probe_vfs_getname.sh
new file mode 100755
index 000000000000..d5f5248de927
--- /dev/null
+++ b/tools/perf/tests/shell/probe_vfs_getname.sh
@@ -0,0 +1,30 @@
+# Add vfs_getname probe to get syscall args filenames
+#
+# Arnaldo Carvalho de Melo <acme@kernel.org>, 2017
+
+perf probe -l | grep -q probe:vfs_getname
+had_vfs_getname=$?
+
+cleanup_probe_vfs_getname() {
+	if [ $had_vfs_getname -eq 1 ] ; then
+		perf probe -q -d probe:vfs_getname
+	fi
+}
+
+add_probe_vfs_getname() {
+	local verbose=$1
+	if [ $had_vfs_getname -eq 1 ] ; then
+               line=$(perf probe -L getname_flags | egrep 'result.*=.*filename;' | sed -r 's/[[:space:]]+([[:digit:]]+)[[:space:]]+result->uptr.*/\1/')
+               perf probe $verbose "vfs_getname=getname_flags:${line} pathname=result->name:string"
+	fi
+}
+
+skip_if_no_debuginfo() {
+	add_probe_vfs_getname -v 2>&1 | grep -q "^Failed to find the path for kernel" && return 2
+	return 1
+}
+
+add_probe_vfs_getname || skip_if_no_debuginfo
+err=$?
+cleanup_probe_vfs_getname
+exit $err
-- 
2.13.4

  parent reply	other threads:[~2017-08-14 16:27 UTC|newest]

Thread overview: 26+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2017-08-14 16:27 [GIT PULL 00/19] perf/core improvements and fixes Arnaldo Carvalho de Melo
2017-08-14 16:27 ` Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 01/19] perf scripting python: Add ppc64le to audit uname list Arnaldo Carvalho de Melo
2017-08-14 16:27   ` Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 02/19] perf vendor events powerpc: remove suffix in mapfile Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 03/19] perf vendor events powerpc: Update POWER9 events Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 04/19] perf stat: Fix saved values rbtree lookup Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 05/19] perf tools: Add missing newline to expr parser error messages Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 06/19] perf test: Make 'list' subcommand match main 'perf test' numbering/matching Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 07/19] perf test: Add 'struct test *' to the test functions Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 08/19] perf test: Add infrastructure to run shell based tests Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 09/19] perf test: Make 'list' use same filtering code as main 'perf test' Arnaldo Carvalho de Melo
2017-08-14 16:27 ` Arnaldo Carvalho de Melo [this message]
2017-08-14 16:27 ` [PATCH 11/19] perf test shell: Install shell tests Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 12/19] perf test shell: Move vfs_getname probe function to lib Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 13/19] perf test shell: Add test using probe:vfs_getname and verifying results Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 14/19] perf test shell: Add test using vfs_getname + 'perf trace' Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 15/19] perf util: Take elf_name as const string in dso__demangle_sym Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 16/19] perf srcline: Do not consider empty files as valid srclines Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 17/19] perf record: Fix wrong size in perf_record_mmap for last kernel module Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 18/19] perf report: Fix module symbol adjustment for s390x Arnaldo Carvalho de Melo
2017-08-14 16:27 ` [PATCH 19/19] perf test shell: Add uprobes + backtrace ping test Arnaldo Carvalho de Melo
2017-08-14 17:39 ` [GIT PULL 00/19] perf/core improvements and fixes Ingo Molnar
2017-08-14 17:39   ` Ingo Molnar
2017-08-14 17:52   ` Arnaldo Carvalho de Melo
2017-08-14 17:52     ` Arnaldo Carvalho de Melo

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20170814162741.6101-11-acme@kernel.org \
    --to=acme@kernel.org \
    --cc=acme@redhat.com \
    --cc=adrian.hunter@intel.com \
    --cc=dsahern@gmail.com \
    --cc=jolsa@kernel.org \
    --cc=linux-kernel@vger.kernel.org \
    --cc=linux-perf-users@vger.kernel.org \
    --cc=mingo@kernel.org \
    --cc=mpetlan@redhat.com \
    --cc=namhyung@kernel.org \
    --cc=tmricht@linux.vnet.ibm.com \
    --cc=wangnan0@huawei.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.